@echo OFF

:@BeginSearchReplaceBuild
set Progress=SR32
echo.
echo Building SearchReplace (file-patcher) demo. Please wait...
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
set libexist=TRUE
for %%f in (cxpos,GetOpts,QuoteStr,FileScan) do if not exist lib\cxpos.lib\%%f.pas echo unit %%f is not found
for %%f in (cxpos,GetOpts,QuoteStr,FileScan) do if not exist lib\cxpos.lib\%%f.pas set libexist=
if not "%libexist%"=="TRUE" goto @erLibCXNotExists

set D_OVR=-$C- -$D- -$R- -b -q -n
set libexist=
if not exist demos\SearchReplace\SR32.dpr goto @SkipSearchReplaceBuild

:@buildSearchReplace
:building SearchReplace (file-patcher) demo
cd demos\SearchReplace\
dcc32 %D_OVR% sr32.dpr
cd   ..\..
echo.
echo - Done building SearchReplace (file-patcher) demo.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:@EndSearchReplaceBuild
goto @BeginSpeedTestBuild


:@SkipSearchReplaceBuild
echo Can not build SearchReplace (file-patcher) demo
goto @BeginSpeedTestBuild


:@BeginSpeedTestBuild
set Progress=Speed
echo.
echo Building SpeedTest demo. Please wait...
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
set libexist=TRUE
for %%f in (Searches,mwTSearch,FastStrings,FastStringFuncs) do if not exist lib\others.lib\%%f.pas echo unit %%f is not found
for %%f in (Searches,mwTSearch,FastStrings,FastStringFuncs) do if not exist lib\others.lib\%%f.pas set libexist=
if not "%libexist%"=="TRUE" goto @erLibOtherNotExists

set libexist=
if not exist demos\SpeedTest\SpeedTest.dpr goto @SkipSpeedTestBuild

:@buildSpeedTest
:building SpeedTest demo
cd demos\SpeedTest\
dcc32 %D_OVR% SpeedTest.dpr
cd   ..\..
echo.
echo - Done building SpeedTest demo
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

:@EndSpeedTestBuild
goto @CleanUpDCUs

:@SkipSpeedTestBuild
echo Can not build SpeedTest demo
goto @CleanUpDCUs

:@erLibCXNotExists
echo.
echo ~ Error! One or more required cxpos library is not exist
echo ~ Can not build Search Replace (file-patcher) demo
goto @Aborted

:@erLibOtherNotExists
echo.
echo ~ Error! One or more required search library/component is not exist
echo ~ Can not build SpeedTest demo
goto @Aborted

:@Aborted
echo.
echo ~ Some of building aborted.
goto @CleanUpDCUs

:@CleanUpDCUs
echo.
echo - Cleaning up DCU's...
if "OS"=="Windows_NT" goto @CleanUpWinNT

:@CleanUpWin9X
for %%u in (demos\SearchReplace\*.dcu) do if exist %%u del %%u
for %%u in (demos\SpeedTest\*.dcu) do if exist %%u del %%u
for %%u in (lib\cxpos.lib\*.dcu) do if exist %%u del %%u
for %%u in (lib\others.lib\*.dcu) do if exist %%u del %%u
goto @DoneBuilding

:@CleanUpWinNT
rem del *.dcu /s { disastrous command if executed under ($DELPHI) path :) }
goto @CleanUpWin9X
goto @DoneBuilding

:@DoneBuilding
echo - Building process all done.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
goto @End

:@End
set Progress=
set D_OVR=
